function [x,iter] = SOR ( A, b, x0, omega,TOL, Nmax )

%SOR          approximate the solution of the linear system Ax = b by applying
%             the SOR method (successive over-relaxation)

[n,n]=size(A); iter=0;
r=b-A*x0';
r0=norm(r);
normb=norm(b);
err=norm(r)/normb;
x_old=x0;
x=x0;
while err>TOL & iter<Nmax
    iter=iter+1;
    
    for i=1:n
        s=0;
        s=sum(A(i,1:i-1).*x(1:i-1));
        s=s+sum(A(i,i+1:n).*x_old(i+1:n));
        x(i)=(1-omega)*x_old(i)+omega*(b(i)-s)/A(i,i);
    end
    x_old=x;
    r=b-A*x';
    err=norm(r)/normb;
end
